/*
 * button.c
 *
 * Created: 2019/01/28 0:33:47
 *  Author: J-Sugita
 */ 

#include <avr/io.h>
#include "button.h"

//
void	Button_Init(void)
{
	//|[gݒ肷
	BUTTON_DDR	&= ~(1 << BUTTON_BIT);	//͕
	BUTTON_PORT	|= (1 << BUTTON_BIT);	//vAbv
}

//{^̉Ԃ𔻒肷
//E̊ԊuŌĂяoĒÕ{^ԂƔr邱ƂŌ݂̏Ԃ𔻒肷B
EButtonState	Button_ButtonState(void)
{
	static	uint8_t	prevPin = 0x00;		//XCb`EItԂ\
	static	uint8_t holdCount = 0;
	uint8_t	nowBtnState;
	
	uint8_t	nowPin = ~BUTTON_PIN & (1 << BUTTON_BIT);	//XCb`EÎƂ'0'AIt̂Ƃ'0'

	if (prevPin == 0 && nowPin != 0)
	{
		nowBtnState = ButtonOn;
	}
	else if (prevPin != 0 && nowPin != 0)
	{
		if (holdCount == MAX_HOLD_COUNT)
		{
			nowBtnState = ButtonLongHold;
		}
		else
		{
			nowBtnState = ButtonShortHold;
			holdCount++;
		}
	}
	else if (prevPin != 0 && nowPin == 0)
	{
		nowBtnState = ButtonOff;
		holdCount = 0;
	}
	else
	{
		nowBtnState = ButtonRelease;
	}

	prevPin = nowPin;
	
	return nowBtnState;
}
